# -*- coding: utf-8 -*-
"""
Created on Wed Sep 10 09:53:59 2014

@author: Graficacion FCC BUAP 2014 otoño (MMO)

Objetos en la UI

   lineEdit_1    : Entrada del angulo en grados
   pushButton_1  : Ejecuta
   pushButton_2  : Limpia
   
   widget_dib    : Widget para dibujar 
   
"""
import sys, math
from PyQt4 import QtGui, QtCore
from qt_01 import Ui_MainWindow

# clase Principal
class Principal(QtGui.QMainWindow):
    
    p1 = QtCore.QPointF(-50, -25)
    p2 = QtCore.QPointF( 50, -25)
    p3 = QtCore.QPointF( 50,  25)
    p4 = QtCore.QPointF(-50,  25)
    pc = QtCore.QPointF(0,  0)
    
    cuadro = [p1,p2,p3,p4]
    
    ang = 0.0

    
    def __init__(self):
        super(Principal, self).__init__()        
        # Set up the user interface from Designer.
        self.ui = Ui_MainWindow()
        self.ui.setupUi(self)
        self.initUI()
        
    def initUI(self):   
        self.ui.lineEdit_1.setText('15')

        self.wd = self.ui.widget_dib
        pos = self.wd.pos()
        self.x0 = pos.x()
        self.y0 = pos.y()        
        
        self.w = self.wd.width()
        self.h = self.wd.height()
        self.pc.setX(self.w / 2)        
        self.pc.setY(self.h / 2)   
        
        self.ui.pushButton_1.clicked.connect(self.boton1Click)
        
        self.show()
        
    def boton1Click(self):
        self.ang = float(self.ui.lineEdit_1.text())
        self.wd.repaint()
        
    def paintEvent(self, e):

        qp = QtGui.QPainter()
        qp.begin(self)
        self.dibuja(qp)
        qp.end()
                
    def dibuja(self, qp):
        
        # orilla        
        qp.setPen(QtCore.Qt.red)
        qp.drawRect(self.x0,self.y0, self.w,self.h)
        
        # pinta un rectangulo
        qp.setPen(QtCore.Qt.blue)
        
        self.pinta_Fig(qp)
        
    def pinta_Fig(self, qp):
        #print 'Ang =', self.ang        
        
        C  = QtCore.QPointF(self.x0, self.y0)
        Q1 = QtCore.QPointF(0,0)
        Q2 = QtCore.QPointF(0,0)
        
        # aplicar la rotacion de un àngulo: ang
        angR = self.ang*math.pi/180
        ca = math.cos(angR)
        sa = math.sin(angR)
        for kk in range(4):
            xx = self.cuadro[kk].x()*ca - self.cuadro[kk].y()*sa
            yy = self.cuadro[kk].x()*sa + self.cuadro[kk].y()*ca
            self.cuadro[kk].setX(xx)
            self.cuadro[kk].setY(yy)
            #print self.cuadro[kk].x(), self.cuadro[kk].y()
                
        # pinta de hecho        
        for kk in range(3):
            Q1 = C + self.cuadro[kk]   + self.pc
            Q2 = C + self.cuadro[kk+1] + self.pc
            qp.drawLine(Q1,Q2)
            
        Q1 = C + self.cuadro[3] + self.pc
        Q2 = C + self.cuadro[0] + self.pc
        qp.drawLine(Q1,Q2)
        

def main():
    app = QtGui.QApplication(sys.argv)
    ejem = Principal()
    sys.exit(app.exec_())
        
if __name__ == '__main__':
    main() 